from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, String, Int, Float

Rnaplex_V0_1_0 = CommandToolBuilder(tool="RNAplex", base_command=["RNAplex"], inputs=[ToolInput(tag="in_detailed_help", input_type=Boolean(optional=True), prefix="--detailed-help", doc=InputDocumentation(doc="Print help, including all details and hidden\noptions, and exit")), ToolInput(tag="in_target", input_type=File(optional=True), prefix="--target", doc=InputDocumentation(doc="File containing the target sequence.")), ToolInput(tag="in_accessibility_dir", input_type=String(optional=True), prefix="--accessibility-dir", doc=InputDocumentation(doc="Location of the accessibility profiles.")), ToolInput(tag="in_binary", input_type=Boolean(optional=True), prefix="--binary", doc=InputDocumentation(doc="Allow the reading and parsing of memory dumped\nopening energy file\n(default=off)")), ToolInput(tag="in_param_file", input_type=File(optional=True), prefix="--paramFile", doc=InputDocumentation(doc="Read energy parameters from paramfile, instead\nof using the default parameter set.")), ToolInput(tag="in_temp", input_type=Int(optional=True), prefix="--temp", doc=InputDocumentation(doc="Rescale energy parameters to a temperature T.\nDefault is 37C.")), ToolInput(tag="in_interaction_length", input_type=Int(optional=True), prefix="--interaction-length", doc=InputDocumentation(doc="Maximal length of an interaction\n(default=`40')")), ToolInput(tag="in_extension_cost", input_type=Int(optional=True), prefix="--extension-cost", doc=InputDocumentation(doc="Cost to add to each nucleotide in a duplex\n(default=`0')")), ToolInput(tag="in_probe_mode", input_type=Boolean(optional=True), prefix="--probe-mode", doc=InputDocumentation(doc="Compute Tm for probes  (default=off)")), ToolInput(tag="in_probe_concentration", input_type=Float(optional=True), prefix="--probe-concentration", doc=InputDocumentation(doc="Set the probe concentration for the Tm\ncomputation\n(default=`0.1')")), ToolInput(tag="in_na_concentration", input_type=String(optional=True), prefix="--na-concentration", doc=InputDocumentation(doc="Set the Na+ concentration for the Tm")), ToolInput(tag="in_mg_concentration", input_type=Int(optional=True), prefix="--mg-concentration", doc=InputDocumentation(doc="Set the Mg2+ concentration for the Tm")), ToolInput(tag="in_k_concentration", input_type=Float(optional=True), prefix="--k-concentration", doc=InputDocumentation(doc="Set the K+ concentration for the Tm computation\n(default=`1.0')")), ToolInput(tag="in_tris_concentration", input_type=Float(optional=True), prefix="--tris-concentration", doc=InputDocumentation(doc="Set the tris+ concentration for the Tm\ncomputation\n(default=`1.0')")), ToolInput(tag="in_fast_folding", input_type=Int(optional=True), prefix="--fast-folding", doc=InputDocumentation(doc="Speedup of the target search\n(default=`0')")), ToolInput(tag="in_scale_accessibility", input_type=Float(optional=True), prefix="--scale-accessibility", doc=InputDocumentation(doc="Rescale all opening energy by a factor V\n(default=`1.0')")), ToolInput(tag="in_constraint", input_type=Boolean(optional=True), prefix="--constraint", doc=InputDocumentation(doc="Calculate structures subject to constraints.\n(default=off)")), ToolInput(tag="in_alignment_mode", input_type=Boolean(optional=True), prefix="--alignment-mode", doc=InputDocumentation(doc="Tells RNAplex to compute interactions based on")), ToolInput(tag="in_convert_to_bin", input_type=Boolean(optional=True), prefix="--convert-to-bin", doc=InputDocumentation(doc="If set, RNAplex will convert all opening energy\nfile in a directory set by the -a option into\nbinary opening energy files\n(default=off)")), ToolInput(tag="in_duplex_distance", input_type=Int(optional=True), prefix="--duplex-distance", doc=InputDocumentation(doc="Distance between target 3' ends of two\nconsecutive duplexes\n(default=`0')")), ToolInput(tag="in_energy_threshold", input_type=Int(optional=True), prefix="--energy-threshold", doc=InputDocumentation(doc="Minimal energy for a duplex to be returned\n(default=`-100000')")), ToolInput(tag="in_produce_ps", input_type=String(optional=True), prefix="--produce-ps", doc=InputDocumentation(doc="Draw an alignment annotated interaction from")), ToolInput(tag="in_program", input_type=String(), position=0, doc=InputDocumentation(doc="-q, --query=STRING            File containing the query sequence.")), ToolInput(tag="in_alignments", input_type=String(), position=2, doc=InputDocumentation(doc="(default=off)")), ToolInput(tag="in_rna_plex", input_type=String(), position=0, doc=InputDocumentation(doc="-L, --WindowLength=INT        Tells how large the region around the target")), ToolInput(tag="in_interaction", input_type=String(), position=0, doc=InputDocumentation(doc="(default=`1')"))], outputs=[], container="quay.io/biocontainers/viennarna:2.4.17--py36hd181a71_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Rnaplex_V0_1_0().translate("wdl")

